#!/usr/bin/php
<?php

$db_in = new PDO('sqlite:test.db');
$db_in->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

unlink("reparata.db");
$db_out = new PDO("sqlite:reparata.db");
$db_out->exec("PRAGMA foreign_keys=OFF");
$db_out->exec("BEGIN TRANSACTION");

//$tables = $db_in->query("SELECT * FROM sqlite_master WHERE type = 'table' AND name='facturi'");
$tables = $db_in->query("SELECT * FROM sqlite_master WHERE type = 'table'");

foreach($tables as $table)
{
	echo "Creating $table[name]...\n";
	$db_out->exec($table["sql"]);
	
	$sth_in = $db_in->prepare("SELECT * FROM $table[name] WHERE id = ?");
	$placeholders = null;
	$last_nr = null;
	$total = 0;
	
	for($i = 1; $i < 10000; $i++)
	{
		try
		{
			$sth_in->execute(array($i));
			
			if(empty($placeholders))
			{
				$placeholders = rtrim(str_repeat("?,", $sth_in->columnCount()), ",");
				$sth_out = $db_out->prepare("INSERT INTO $table[name] VALUES ($placeholders)");
			}
			
			if(FALSE === ($row = $sth_in->fetch(PDO::FETCH_ASSOC)))
				continue;
			
			if(!empty($row["nr"]))
				$last_nr = $row["nr"];
			
			$sth_out->execute(array_values($row));
			
			$total++;
		}
		catch(PDOException $e)
		{
			if(!empty($last_nr))
				echo "    Nr pierdut: ", ++$last_nr, "\n";
			//error_log($e->getMessage());
		}
	}
	
	echo "    Total: ", $total, "\n";
}

$indexes = $db_in->query("SELECT * FROM sqlite_master WHERE type = 'index'");

foreach($indexes as $index)
{
	if(!empty($index["sql"]))
	{
		echo "Creating $index[name]...\n";
		$db_out->exec($index["sql"]);
	}
	
}

$db_out->exec("COMMIT TRANSACTION");
